/* $Id: s3_io.inc,v 1.6 1998/11/24 18:28:09 marcus Exp $
******************************************************************************

	NOTE: This file is obsolete and will be replaced by s3_mmio.inc
	(one day, step by step...), DON'T USE FOR NEW DRIVERS!

******************************************************************************

   S3 (Vision964) I/O

   Copyright (C) 1995	Steffen Seeger	[seeger@ggi-project.org]

   Permission is hereby granted, free of charge, to any person obtaining a
   copy of this software and associated documentation files (the "Software"),
   to deal in the Software without restriction, including without limitation
   the rights to use, copy, modify, merge, publish, distribute, sublicense,
   and/or sell copies of the Software, and to permit persons to whom the
   Software is furnished to do so, subject to the following conditions:

   The above copyright notice and this permission notice shall be included in
   all copies or substantial portions of the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
   THE AUTHOR(S) BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
   IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
   CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

******************************************************************************

	This code was derived from the following source of information:
	[1]	S3 Vision964 Data Book, (c) 1994 S3 Incorporated

******************************************************************************
*/

#include "kgi.h"

#define S3IO_BASE   0x03C0
#define S3IO_REGION 0x03E0-S3IO_BASE

static kgiu16 INS1r;
static kgiu16 CRTI,CRTD;
static kgiu16 FCTRLw;

static void outbMISC(kgiu8 value)
{
  outb(value, MISCw);			/* put value      */
  if (value & MISC_COLOR_IO)		/* adjust IO base */
    { CRTI=CRTIc; CRTD=CRTDc; INS1r=INS1rc; FCTRLw=FCTRLwc; }
   else
    { CRTI=CRTIm; CRTD=CRTDm; INS1r=INS1rm; FCTRLw=FCTRLwm; };
}

static inline void outbCRT(kgiu8 value, kgiu8 reg) 
{
	outw((value << 8) | reg, CRTI);
}

static inline kgiu8 inbCRT(kgiu8 reg)
{
	outb(reg, CRTI); return inb(CRTD);
}

static inline void outbATC(kgiu8 val, kgiu8 reg)
{
	inb(INS1r);		/* reset AFF */
	outb(reg, ATCI);	/* set index */
	outb(val, ATCDw);	/* write value */
	inb(INS1r);		/* reset AFF */
	outb(ATCI_ENABLEDISPLAY, ATCI);
}

static inline void outbSEQ(kgiu8 value, kgiu8 reg)
{ outw((value << 8) | reg, SEQI); }

static inline kgiu8 inbSEQ(kgiu8 reg)
{ outb(reg, SEQI); return inb(SEQD); }


static inline void outbGRC(kgiu8 value, kgiu8 reg)
{ outw((value << 8 ) | reg, GRCI); }

static inline kgiu8 inbGRC(kgiu8 reg)
{ outb(reg, GRCI); return inb(GRCD); }


static void s3_unlock(void)
{
  outbCRT(CR38_MAGIC, 0x38);		/* unlock CR30-CR3F */
  outbCRT(CR39_MAGIC, 0x39);		/* unlock CR40-CRFF */
  outbCRT( inbCRT(0x33)
          & ~(CR33_UNLOCK_VDE | CR33_LOCK_DAC | CR33_LOCK_PALETTE), 0x33);

  /* there are more locks, but this should work after reboot. */
}

static void s3_lock(void)
{
  outbCRT(0, 0x38);			/* lock CR30-CR3F */
  outbCRT(0, 0x39);			/* lock CR40-CRFF */
}

/*
	generalized DAC output functions
*/

static kgiu16 dac_port[4] ={ 0x3C8, 0x3C9, 0x3C6, 0x3C7 };

#define	DAC_DECODE	0x0F	/* RS[0:3] are possible	*/
#define	CHECK_DAC_REG	if(dac_reg & ~DAC_DECODE) \
                          printk("%s: warning - DAC RegisterSelect "\
                          "lines truncated: %x to %x.\n", __FILE__,\
                          dac_reg, dac_reg &= DAC_DECODE)

void outbDAC(kgiu8 value, kgiu8 dac_reg)
{
  CHECK_DAC_REG;

  outb(0x55,CRTI); outb((inb(CRTD) & ~CR55_DAC_MASK) | (dac_reg >> 2), CRTD);
  outb(value, dac_port[dac_reg & 0x03]);

  #ifdef DEBUG_IO
    TRACE(printk("DAC_%.1x <- %.2x\n", dac_reg, value));
  #endif
}

kgiu8 inbDAC(kgiu8 dac_reg)
{
  #ifdef DEBUG_IO
   register kgiu8 foo;
  #endif
  
   CHECK_DAC_REG;

   outb(0x55,CRTI); outb((inb(CRTD) & ~CR55_DAC_MASK) | (dac_reg >> 2), CRTD);

   #ifdef DEBUG_IO
     foo = inb(dac_port[dac_reg & 0x03]);
     TRACE(printk("DAC_%.1x -> %.2x\n",dac_reg, foo));
     return foo;
   #else
     return inb(dac_port[dac_reg & 0x03]);
   #endif
 }

void insbDAC(kgiu16 dac_reg, void *buf, kgi_uint count)
{
  CHECK_DAC_REG;

  outb(0x55, CRTI); outb((inb(CRTD) & ~CR55_DAC_MASK) | (dac_reg >> 2), CRTD);
  insb(dac_port[dac_reg & 0x03], buf, count);
}

void outsbDAC(kgiu16 dac_reg, void *buf, kgi_uint count)
{
  CHECK_DAC_REG;

  outb(0x55, CRTI); outb((inb(CRTD) & ~CR55_DAC_MASK) | (dac_reg >> 2), CRTD);
  outsb(dac_port[dac_reg & 0x03], buf, count);
}

/*
	clock I/O functions
*/

#define	CLK_DECODE	CR42_DCLK_MASK
#define	CHECK_CLK_VAL	if (value & ~CLK_DECODE) \
                          printk("%s: warning - ClockSelect lines truncated:"\
                          " %x to %x.\n", __FILE__, value, value &= CLK_DECODE);

void setCLK(int value)
{
  CHECK_CLK_VAL;
  outbCRT((inbCRT(0x42) & ~CR42_DCLK_MASK) | value, 0x42);
}

int getCLK(void)
{
  return inbCRT(0x5C) & CR5C_CLOCK_MASK;
}


#define NoSEQRegs	0x05
#define	NoCRTRegs	0x80
#define NoGRCRegs	0x09
#define NoATCRegs	0x15

struct statetable
{
   kgiu8 MISC;
   kgiu8 FCTRL;
   kgiu8 SEQ[NoSEQRegs];
   kgiu8 CRT[NoCRTRegs];
   kgiu8 GRC[NoGRCRegs];
   kgiu8 ATC[NoATCRegs];
};

#ifdef NEED_SAVE_STATE
static void save_SEQ(kgiu8 *buf)
{
  int i;

  for(i = 0; i < NoSEQRegs; i++)
   {
     outb(i, SEQI); *(buf++)=inb(SEQD);
     #ifdef DEBUG_IO
       if (!(i & 0xF))
         printk("\n%.2x: ",i);
       printk("%.2X, ",*(buf-1));
     #endif
   }
  #ifdef DEBUG_IO
    printk("\n");
  #endif
}
#endif

static void restore_SEQ(kgiu8 *buf)
{ register kgiu8 i;
  for(i=0; i < NoSEQRegs; i++)
   { outb(i,SEQI); outb(*(buf++), SEQD);}
}

#ifdef NEED_SAVE_STATE
static void save_CRT(kgiu8 *buf)
{
  int i;

  for(i = 0; i < NoCRTRegs; i++)
   { 
     outb(i, CRTI); *(buf++)=inb(CRTD);
     #ifdef DEBUG_IO
       if (!(i & 0xF))
         printk("\n%.2x: ",i);
       printk("%.2X, ",*(buf-1));
     #endif
   }
  #ifdef DEBUG_IO
    printk("\n");
  #endif
}
#endif

static void restore_CRT(kgiu8 buf[])
{
  register kgiu8 i;

  outbCRT(inbCRT(CRT_VSYNCEND) & ~CR11_LOCKTIMING, CRT_VSYNCEND);
  for(i = 0x00; i < 0x19; i++) outbCRT(buf[i], i); 
  for(i = 0x30; i < 0x3D; i++) outbCRT(buf[i], i);
  for(i = 0x40; i < 0x6E; i++)
    switch(i) 
     {
       case 0x42:
	 outbCRT((inbCRT(i) & CR42_DCLK_MASK) | (buf[i] & ~CR42_DCLK_MASK), i); 
	 break;
       case 0x55:
	 outbCRT((inbCRT(i) & CR55_DAC_MASK) | (buf[i] & ~CR55_DAC_MASK), i);
         break;
       default: 
         outbCRT(buf[i], i);
     }
}

#ifdef NEED_SAVE_STATE
static void save_GRC(kgiu8 *buf)
{
  int i;

  for(i = 0; i < NoGRCRegs; i++) 
   {
     outb(i, GRCI); *(buf++)=inb(GRCD);
     #ifdef DEBUG_IO
       if (!(i & 0xF))
         printk("\n%.2x: ",i);
       printk("%.2X, ",*(buf-1));
     #endif
   }
  #ifdef DEBUG_IO
    printk("\n");
  #endif
}
#endif

static void restore_GRC(kgiu8 *buf)
{
  register kgiu8 i;

  for(i = 0; i < NoGRCRegs; i++)
    {
      outb(i, GRCI); outb(*(buf++), GRCD);
      #ifdef DEBUG_IO
        if(!(i & 0xF))
          printk("\n%.2x: ",i);
        printk("%.2X, ",*(buf-1));
      #endif
    }
  #ifdef DEBUG_IO
    printk("\n");
  #endif
}

#ifdef NEED_SAVE_STATE
static void save_ATC(kgiu8 *buf)
{
  int i;

  for(i = 0; i < NoATCRegs; i++)
   { 
     inb(INS1r); outb(i, ATCI); /* reset AFF and setup index */
     *(buf++)=inb(ATCDr);
     #ifdef DEBUG_IO
       if (!(i & 0xF))
         printk("\n%.2x: ",i);
       printk("%.2X, ",*(buf-1));
     #endif
   }
  inb(INS1r); outb( ATCI_ENABLEDISPLAY, ATCI);
}
#endif

static void restore_ATC(kgiu8 *buf)
{
  register kgiu8 i;
  /* inb(INS1r);	 initialize AFF */
  for(i = 0; i < NoATCRegs; i++)
   { 
     inb(INS1r); outb(i,ATCI); outb(*(buf++),ATCDw);
     #ifdef DEBUG_IO
       if(!(i & 0x0F))
         printk("\n%.2x: ",i);
       printk("%.2X, ",*(buf-1));
     #endif
   }
  inb(INS1r); outb(ATCI_ENABLEDISPLAY, ATCI);
}

#ifdef NEED_SAVE_STATE
static void save_state(struct statetable *state)
{
  s3_unlock();
  state->MISC  = inb(MISCr);	/* save miscellaneous output reg */
  #ifdef DEBUG_IO
    printk("MISC: %.2X\n",state->MISC);
  #endif
  state->FCTRL = inb(FCTRLr);	/* save feature control reg */
  save_SEQ(state->SEQ);	/* save sequencer regs */
  save_CRT(state->CRT);	/* save cathode ray tube controller regs */
  save_GRC(state->GRC);	/* save graphics controller regs */
  save_ATC(state->ATC);	/* save attribute controller regs */
}
#endif

static void restore_state(struct statetable *state)
{
   outbMISC((inb(MISCr) & MISC_CLOCK_MASK) | state->MISC);
   outb(state->FCTRL, FCTRLw);
   restore_SEQ(state->SEQ);
   restore_CRT(state->CRT);
   restore_GRC(state->GRC);
   restore_ATC(state->ATC);
}

static kgiu16 fifo_masks[13] =
{
  0x0800, 0x1000, 0x2000, 0x4000, 
  0x8000, 0x0001, 0x0002, 0x0004, 
  0x0008, 0x0010, 0x0020, 0x0040 
};

static inline void wait_fifo(int i)
{
  register kgiu16 mask = fifo_masks[(i < 13) ? i : 12];
  while (mask & inw(ECR_GP_STATUS));
}

#ifdef DEBUG_IO
static void dump_state(struct statetable *state)
{ int i;
  printk("%.2x\n",state->MISC);
  printk("%.2x\n",state->FCTRL);
  for(i = 0; i < NoSEQRegs; i++)
   { if(!(i & 0xF)) printk("\n%.2x: ",i); printk("%.2x, ",state->SEQ[i]); }
  for(i = 0; i < NoCRTRegs; i++)
   { if(!(i & 0xf)) printk("\n%.2x: ",i); printk("%.2x, ",state->CRT[i]); }
  for(i = 0; i < NoGRCRegs; i++)
   { if(!(i & 0xF)) printk("\n%.2x: ",i); printk("%.2x, ",state->GRC[i]); }
  for(i = 0; i < NoATCRegs; i++)
   { if(!(i & 0xF)) printk("\n%.2x: ",i); printk("%.2x, ",state->ATC[i]); }
}
#endif

