/*    
******************************************************************************
	wd_probe -- probe for Western Digital (Paradise) chipsets
******************************************************************************

   Copyright (C) 1997 by Brian S. Julin, <bri@calyx.com>

   Permission is hereby granted, free of charge, to any person obtaining a
   copy of this software and associated documentation files (the "Software"),
   to deal in the Software without restriction, including without limitation
   the rights to use, copy, modify, merge, publish, distribute, sublicense,
   and/or sell copies of the Software, and to permit persons to whom the
   Software is furnished to do so, subject to the following conditions:

   The above copyright notice and this permission notice shall be included in
   all copies or substantial portions of the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
   THE AUTHOR(S) BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
   IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
   CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
******************************************************************************
*/


#include <sys/perm.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>

#include "WD/wd_family.h"
#include "WD/wd90c1x.h"

kgiu16 CRTI, CRTD, INS1r;
static char *wd_chipset_names[WD_HOWMANY_CHIPSETS] = { WD_VERBOSE_NAMES };

/* So as not to break includes */
char* chipset;

void main (void) {
  struct kgi_wd_chipset chipset;

  iopl(3);

  memset(chipset.revstring, 0, (CRT_CHIPREV6 - CRT_CHIPSIG1 + 2));

  kgi_chipset_wd_detect(&chipset);
  if (! chipset.revstring[0]) {
    strcpy(chipset.revstring, "N/A\0");
  } 
  printf("Detected Chipset %s (Revision info: %s)\n", 
	 wd_chipset_names[chipset.chiptype], chipset.revstring);

  kgi_chipset_wd_findram(&chipset);
  printf("%dKBytes RAM%s\n", chipset.chipset.ramsize / 1024,
	 ((chipset.features & BANKING_RAM) ? ", with banking" : ""));

}





